import snap
import snap
import math
import random
import time

start = time.time()

print('Loading Graph.....')
G2in=snap.LoadEdgeList(snap.PNGraph, "dblp.txt",0,1)   ## Loading Graph
G2 = snap.ConvertGraph(snap.PUNGraph, G2in)         ## Converting the Graph to Undirected Graph  
print('Completed Loading Graph')

end2=time.time()                                   ## Computing the end time

print('Graph Loading takes %f' %(end2-start))
vector = [x.GetId() for x in G2.Nodes()]           ## Node ID of G2 Graph

no_edges=G2.GetEdges()                             ## No. of Edges of G2
no_vertices=G2.GetNodes()                          ## No. of Vertices of G2 

print('Extracting SubGraph.....') 
G3 = snap.GetRndESubGraph(G2, int(math.floor(0.2*no_edges)))   ## Create Random SubGraph G3 with 0.7*no_edges of G2
print('Completed Extraction of Graph Graph')

no_edges3=G3.GetEdges()                  ## Get the no of Edges of G3
no_vertices3=G3.GetNodes()               ## Get the no of vertices of G3

print('Vertices: %d'%no_vertices3)
print('Edges: %d'%no_edges3)        
RandomNodeVar=[var.GetId() for var in G3.Nodes()]   ## Create a vector of Node Id for G3
start = time.time()                                 ## Start Timer

RandomSNode=random.sample(RandomNodeVar,int(math.floor(0.01*len(RandomNodeVar)))) ## Sample the Node Id vector of length defined as second argument
##RandomSNode.sort() ## Sort the Random Vector 

#vecDeg=dict((j.GetId(),j.GetDeg()) for j in G3.Nodes() if j.GetId() in RandomNodeVar)
#vecDeg2=dict((j.GetId(),j.GetDeg()) for j in G3.Nodes())
vecDegmax=max([j.GetDeg() for j in G3.Nodes()])  ## Maximum degree of graph G3

print('Sample Nodes:%d'% len(RandomSNode))

Fsrc=[]  ## Empty List of Fsrc
Fdst=[]  ## Empty List of Fdst
Fwgt=[]  ## Empty List of Fwgt
tempsrc=[]  ## Empty List of tempsrc
tempdst=[]  ## Empty List of tempdst
tempwgt=[]  ## Empty List of tempwgt

TOP=1000 ## Take 1000 best links
##score=0
q=0
countwgt=0


xsltn=[0 for j in range(0,no_vertices3)]  ## x-solution of vertices3
NodeId=[j for j in range(0,no_vertices3)] ## Creating NodeIds for Node Vector for graph G3(RandomNodeVar).
 
NodeDict=dict((RandomNodeVar[i],i) for i in NodeId)  ## Since the new graph has different Node order than original graph when represented in 							     ## arrays. I have used two arrays NodeDict and Dict Node for conversion between New NodeId
                                                     ## & original NodeId.  
DictNode=dict((i,RandomNodeVar[i]) for i in NodeId) 


xsltn2=xsltn
residual=xsltn2
FinalMaxIndex=0
tol = 1e-4    # Tolerance limit
n=1                             
alpha = (float(1)/vecDegmax)*0.9 # aplha value in katz computation
countiterloop=0
c=0

print('Starting Katz Computation .............')
print('No. of Random Nodes Selected %d' %len(RandomSNode))
for i in RandomSNode:            ## Computing the score between all nodes and Nodes which are radomly sampled. The algorithm is taken paper   					 ## attached in mail
    xsltn=xsltn2
    residual=xsltn2           
    residual[NodeDict[i]]=1
    q=NodeDict[i]
    
    print("Percentage completed: %f" %(float(c)/len(RandomSNode)*100))
    c=c+1
    for j in range(0,no_vertices):
        FinalMaxIndex = q       
             
        if(residual[FinalMaxIndex] < tol):
            break
        else:
            n=residual[FinalMaxIndex]  
            MaxIndexNghb=[NodeDict[valq.GetId()] for valq in G3.Nodes() if G3.IsEdge(valq.GetId(),i)==True]
            xsltn[FinalMaxIndex] = xsltn[FinalMaxIndex] + n 
            residual[FinalMaxIndex] = 0.0;   
            for lkm in MaxIndexNghb: ## MaxIndexNghb is the node neighbours of node I in original graph
                residual[lkm] = residual[lkm]+(alpha*n) 
        q=residual.index(max(residual))
    xsltn[NodeDict[i]]=xsltn[NodeDict[i]]-1              

## The top k list is grown in following way. Initially, the scores (xsltn) are used to fill the array. The they are sorted and new element is ## inserted according.           
    for j in range(0,len(xsltn)):        
        if G3.IsEdge(i,DictNode[j]) == False:    
            if(countwgt < TOP):
                tempsrc.append(i)
                tempdst.append(DictNode[j])  
                tempwgt.append(xsltn[j])
                countwgt=countwgt+1   
            elif(countwgt == TOP): 
                for q in range(0,TOP):
                    q=tempwgt.index(max(tempwgt))
                    Fsrc.append(tempsrc[q])
                    Fdst.append(tempdst[q])
                    Fwgt.append(tempwgt[q])
                    tempwgt[q]=-100
                countwgt=countwgt+1
                tempsrc=[]
                tempwgt=[]
                tempdst=[] 
                for er in range(0,TOP):
                    if Fwgt[er] < xsltn[j]:
                        Fwgt.insert(er,xsltn[j])
                        Fsrc.insert(er,i)
                        Fdst.insert(er,DictNode[j])
                        break
                    else:
                        continue  
                Fwgt=Fwgt[0:TOP]
                Fsrc=Fsrc[0:TOP]
                Fdst=Fdst[0:TOP]
               
            else:
                countwgt = countwgt + 1 
                for er in range(0,TOP):
                    if Fwgt[er] < xsltn[j]:
                        Fwgt.insert(er,xsltn[j])
                        Fsrc.insert(er,i)
                        Fdst.insert(er,DictNode[j])
                        break
                    else:
                        continue
                Fwgt=Fwgt[0:TOP]
                Fsrc=Fsrc[0:TOP]
                Fdst=Fdst[0:TOP]

           

## Checking for Edges in orignal Graph G2
count=0    
for i in range(0,TOP):
    if G2.IsEdge(Fsrc[i],Fdst[i]) == True:
        count=count+1 
     
end=time.time()

print('Time Taken is %f'%(end-start))

print('The precison is %d' %count)
