import snap
import snap
import math
import random
import time

start = time.time()

print('Loading Graph.....')
G2in=snap.LoadEdgeList(snap.PNGraph, "facebook.txt",0,1)   ## Loading Graph
G2 = snap.ConvertGraph(snap.PUNGraph, G2in)                 ## Converting the Graph to Undirected Graph  
print('Completed Loading Graph')

end2=time.time()

print('Graph Loading takes %f' %(end2-start))
vector = [x.GetId() for x in G2.Nodes()]       ## Getting all Node IDs

no_edges=G2.GetEdges()
no_vertices=G2.GetNodes()

print('Extracting SubGraph.....')
G3 = snap.GetRndESubGraph(G2, int(math.floor(0.7*no_edges)))   ## Creating new sub graph G3
print('Completed Extraction of Graph Graph')
no_edges3=G3.GetEdges()  ## Computing No of edges
no_vertices3=G3.GetNodes() ## Computing No of vertices

print('Vertices: %d'%no_vertices3)
print('Edges: %d'%no_edges3)
RandomNodeVar=[var.GetId() for var in G3.Nodes()] ## Creating array of NodeIds of G3. Note the NodeIds do not match array indices
start = time.time()
RandomSNode=random.sample(RandomNodeVar,int(math.floor(0.7*len(RandomNodeVar))))  ## Randomly sampling the G3 NodeIds
RandomSNode.sort()

vecDeg=dict((j.GetId(),j.GetDeg()) for j in G3.Nodes() if j.GetId() in RandomNodeVar) ## Dictionary for storing NodeIds and their degree
vecDeg2=dict((j.GetId(),j.GetDeg()) for j in G3.Nodes())



print('Sample Nodes:%d'% len(RandomSNode))

Fsrc=[]
Fdst=[]
Fwgt=[]
tempsrc=[]
tempdst=[]
tempwgt=[]

TOP=1000
score=0
q=0
countwgt=0

alpha =9

countiterloop=0
print('Starting Jaccard coeeficient Computing .............')

print(len(RandomSNode))

for i in RandomSNode:
    countiterloop=countiterloop+1  
    var=[j2.GetId() for j2 in G3.Nodes() if alpha*j2.GetDeg() > vecDeg[i]]
    print(countiterloop,len(var))
    if len(var) != 0:
        for j in var:
            if i != j:
                score=0.0 ## The following is part is the score computation. Pa method, Jaccard method, Adamic-Adar method
                if G3.IsEdge(i,j) == False: 
                    ##var1=[qw.GetId() for qw in G3.Nodes() if G3.IsEdge(qw.GetId(),i)==True]
                    ##var2=[qw1.GetId() for qw1 in G3.Nodes() if G3.IsEdge(qw1.GetId(),j)==True]
                    ##c=var1+var2
                    ##a=list(set(c))
                    ##b=[float(1)/math.log(vecDeg2[qw2]) for qw2 in var1 if qw2 not in var2 if vecDeg2[qw2] != 0 if vecDeg2[qw2] != 1]
                    score = vecDeg[i]*vecDeg2[j]
                
                else:  
                    continue  
        
                if(countwgt < TOP):
                    tempsrc.append(i)
                    tempdst.append(j)  
                    tempwgt.append(score)
                    countwgt=countwgt+1   
                elif(countwgt == TOP): 
                    for q in range(0,TOP):
                        q=tempwgt.index(max(tempwgt))
                        Fsrc.append(tempsrc[q])
                        Fdst.append(tempdst[q])
                        Fwgt.append(tempwgt[q])
                        tempwgt[q]=-100
                    countwgt=countwgt+1
                    for er in range(0,TOP):
                        if Fwgt[er] < score:
                            Fwgt.insert(er,score)
                            Fsrc.insert(er,i)
                            Fdst.insert(er,j)
                            break
                    Fwgt=Fwgt[0:TOP]
                    Fsrc=Fsrc[0:TOP]
                    Fdst=Fdst[0:TOP]
               
                else:
                    countwgt = countwgt + 1 
                    for er in range(0,TOP):
                        if Fwgt[er] < score:
                            Fwgt.insert(er,score)
                            Fsrc.insert(er,i)
                            Fdst.insert(er,j)
                            break
                    Fwgt=Fwgt[0:TOP]
                    Fsrc=Fsrc[0:TOP]
                    Fdst=Fdst[0:TOP]

           

count=0    
for i in range(0,TOP):
    if G2.IsEdge(Fsrc[i],Fdst[i]) == True:
        count=count+1 
     
end=time.time()

print('Time Taken is %f'%(end-start))

print('The precison is %d' %count)
